#ifndef _CLIENT_H
#define _CLIENT_H

#include <map>
#include <string>
#include <set>
#include "protocol.h"
#include "rrdata.h"

using std::set;
using std::map;
using std::string;
using std::pair;


class Client{
public:
	Client() { nextId = 1; }
	~Client();
	unsigned int insertClient(Protocol* client, const char* IP);
	bool CheckIP(string& IP);
	virtual void Reload() = 0;
	virtual void Handle();
	int Size();
	struct t_info;
	t_info* getClientInfo(unsigned int);
	t_info* getClientInfo(const string&);

	struct t_info{
		t_info() { protocol = NULL; IP = ""; deleted = false; }
		t_info(Protocol* protocol_, const char* IP_) { protocol = protocol_; IP = IP_; deleted = false; }
		bool deleted;
		Protocol* protocol;
		string IP;
	};

	enum t_clientType { t_unknown, t_user, t_tester, t_admin, t_rating };

protected:
	typedef pair< int, t_info* > t_cortege;
	typedef map< int, t_info* > t_map;
	t_map clients;
	set<string> IPs;
	unsigned int nextId;

	inline unsigned int getNextId() { return nextId++; }
	virtual t_info* putInfo(Protocol* protocol, const char* IP){ return new t_info(protocol, IP); }
	virtual t_clientType getClass(void){ return t_unknown; }
};

#endif // _CLIENT_H