#ifndef _INTERNAL_STRUCTURES_H
#define _INTERNAL_STRUCTURES_H

#include <string>
#include <time.h>
#include <rrdata.h>
#include <map>

using std::string;
using std::map;
using std::pair;

struct t_expectedResult{
	t_expectedResult() { }
	string result;
	string testNumber;
};

struct t_job{
	t_job() { clientId = 0; coded = true; }
	t_job(const string& _TaskNumber, const string& _CompilerId, const string& _DBId, int _clientId, const string& _TaskId, const string& _ProgramText, const string& _TeamId, unsigned int _Penalty, bool _coded = true) {
		Task = _TaskNumber;
		Compiler = _CompilerId;
		DBId = _DBId;
		clientId = _clientId;
		TaskId = _TaskId;
		ProgramText = _ProgramText;
		TeamId = _TeamId;
		Penalty = _Penalty;
		coded = _coded;
	}
	string Task;
	string Compiler;
	string DBId;
	unsigned int clientId;
	string TaskId;
	string ProgramText;
	string TeamId;
	unsigned int Penalty;
	bool coded;
};

struct t_checkJob{
	string Task;
	t_expectedResult expectedResult;
	string ProgramText;
	string Compiler;
};

struct t_taskData{
	t_taskData() { TaskNumber = 0; Result = '-'; FailsNumber = 0; Penalty = 0; }
	t_taskData(int _TaskNumber, char _Result, int _FailsNumber, int _Penalty) { TaskNumber = _TaskNumber; Result = _Result; FailsNumber = _FailsNumber; Penalty = _Penalty; }
	int TaskNumber;
	char Result;
	int FailsNumber;
	int Penalty;
};

struct t_ratingNode{
	t_ratingNode() { TeamId = 0; SolvedTasks = 0; OverallPenalty = 0; }
	t_ratingNode( int _TeamId, const string& _TeamName ) { TeamId = _TeamId; TeamName = _TeamName; SolvedTasks = 0; OverallPenalty = 0; }
	int TeamId;
	string TeamName;
	int SolvedTasks;
	int OverallPenalty;
	map< int, t_taskData > tasks;
};

struct t_ratingData{
	t_ratingData() { TeamId = 0; TaskNumber = 0; Result = 0; Penalty = 0; }
	t_ratingData(int _TeamId, int _TaskNumber, int _Result, int _Penalty) { TeamId = _TeamId; TaskNumber = _TaskNumber; Result = _Result; Penalty = _Penalty; }
	int TeamId;
	int TaskNumber;
	int Result;
	int Penalty;
};

#endif // _INTERNAL_STRUCTURES_H