#ifndef _TESTER_H
#define _TESTER_H

#include <time.h>
#include <queue>
#include "protocol.h"
#include "client.h"
#include "internal_structures.h"
#include "rrdata.h"

using std::queue;

class Tester: public Client{
public:
	Tester();
	~Tester(){}

	struct t_testerInfo;

	// Reloads IPs
	void Reload(void);
	// return number of checked testers
	int getCheckedTestersNumber(void);
	// return number of ready testers
	int getReadyTestersNumber(void);
	// return first ready tester
	t_testerInfo* getReadyTester(void);
	// make specified tester ready
	void makeReady(unsigned int, RRData&);
	// reactivates all testers
	void Reactivate(const string& tasks);
	// insert task for checking
	void insertJob(const string& TaskId, const string& Task, const string& Compiler, const string& ProgramText, int clientId, const string DBId, const string& TeamId, unsigned int Penalty, bool coded = true);
	void insertJob(const t_job& job);

	struct t_testerInfo: public t_info{
		t_testerInfo() { ready = false; serveTime = 0; reactivated = true; }
		t_testerInfo(Protocol* protocol, const char* IP): t_info(protocol, IP) { ready = false; serveTime = 0; reactivated = true; }
		bool ready;
		t_job job;
		time_t serveTime;
		queue< t_checkJob > checkQueue;
		bool reactivated;
	};

private:
	virtual t_info* putInfo(Protocol*, const char*);
	virtual t_clientType getClass(void){ return t_tester; }
	void appointJobs(void);
	queue<t_job> jobs;
};

#endif // _TESTER_H