#include <mysqlplus.h>

using namespace MySQLPlus;

MySQLPImplementation::MySQLPImplementation()
{
	_mysql = new MYSQL;
}

MySQLPImplementation::~MySQLPImplementation()
{
	delete _mysql;
}


void MySQLP::_register()
{
	_mysqlimp->_family.push_back(this);
}

void MySQLP::_unregister()
{
	vector< MySQLP * >::iterator i;
	for(i=_mysqlimp->_family.begin(); i!=_mysqlimp->_family.end(); i++)
		if( (*i) == this)
		{
			_mysqlimp->_family.erase(i);
			break;
		}
}

MySQLP::MySQLP()
	: _success( true )
	, _connected( false )
{
	_mysqlimp = new MySQLPImplementation;
	_register();
}

MySQLP::MySQLP( const MySQLP &o )
	: _success(o._success)
	, _connected(o._connected)
{
	_mysqlimp = o._mysqlimp;
	_register();
}

MySQLP::~MySQLP()
{
	_unregister();
	if( !_mysqlimp->_family.size() ) delete _mysqlimp;
}

string MySQLP::escapeString( const string &from )
{
	size_t len = from.length() * 2 + 1;
	char *to;
	to = new char[len];
	mysql_real_escape_string( _mysqlimp->_mysql, to, from.c_str(), from.length() );
	string __to( to );
	delete[] to;
	return __to;
}
