#include <mysqlplus.h>

using namespace MySQLPlus;

Connection::Connection(
	const string &_user,
	const string &_password /* = "" */,
	const string &_database /* = "" */,
	const string &_host /* = "localhost" */,
	unsigned int _port /* = 0 */
) : MySQLP()
{
	_success = connect( _user, _password, _database, _host, _port );
}

Connection::Connection( const Connection &o ) : MySQLP( o ) {}

Connection::~Connection() { close(); }

bool Connection::connect(
	const string &_user,
	const string &_password /* = "" */,
	const string &_database /* = "" */,
	const string &_host /* = "localhost" */,
	unsigned int _port /* = 0 */)
{
	if( _connected ) close();
	if( !mysql_init( _mysqlimp->_mysql ) )
	{
		_success = false;
		return false;
	}
	if( !mysql_real_connect( _mysqlimp->_mysql, _host.c_str(), _user.c_str(), _password.c_str(), _database.c_str(), _port, NULL, 0 ) )
	{
		_success = false;
		return false;
	}
	_success = true;
	_connected = true;
	return true;
}

void Connection::close()
{
	if( _connected ) mysql_close( _mysqlimp->_mysql );
	_connected = false;
}

Query Connection::query()
{
	return Query(*this);
}

bool Connection::selectDb( const string &_database )
{
	if( mysql_select_db( _mysqlimp->_mysql, _database.c_str() ) )
	{
		_success = false;
		return false;
	} else return true;
}
