#include <mysqlplus.h>

using namespace MySQLPlus;

Query::Query( const MySQLP &o) : MySQLP( o )
{
	_query = "";
}

Query::Query( const Query &o ) : MySQLP( o )
{
	_query = o._query;
}

void Query::reset()
{
	_query = "";
}

Result Query::store( const String &default_value )
{
	if( mysql_real_query( _mysqlimp->_mysql, _query.c_str(), _query.length() ) )
	{
		_success = false;
		return Result();
	}
	MYSQL_RES *_result;
	_result = mysql_store_result( _mysqlimp->_mysql );
	if( !_result )
	{
		_success = false;
		return Result();
	}
	Result result( _result, default_value );
	mysql_free_result( _result );
	_success = true;
	return result;
}

bool Query::exec()
{
	if( mysql_real_query( _mysqlimp->_mysql, _query.c_str(), _query.length() ) )
	{
		_success = false;
		return false;
	}
	_success = true;
	return true;
}

ULongLong Query::insertId()
{
	return mysql_insert_id( _mysqlimp->_mysql );
}
