#include <mysqlplus.h>

using namespace MySQLPlus;

Row::Row()
	: __basic_row()
	, _res(NULL)
{
}

Row::Row( Result *res, const MYSQL_ROW &row, const String &default_value )
	: __basic_row()
{
	_res = res;
	for(unsigned int i=0; i<_res->_cols; i++)
		if( row[i] ) this->push_back( row[i] );
			else this->push_back( default_value );
}

Row::Row( const Row &o )
	: __basic_row( o )
{
	_res = o._res;
}

const String& Row::operator [] ( long unsigned int i ) const
{
	return static_cast< const __basic_row * >(this)->operator[]( i );
}

String Row::operator [] (const string &field)
{
	return static_cast< __basic_row * >(this)->operator[] ( _res->fieldNumber( field ) );
}

string Row::fieldName( long unsigned int i )
{
	return _res->fieldName( i );
}

long unsigned int Row::fieldNumber( const string &field )
{
	return _res->fieldNumber( field );
}
