#include <mysqlplus.h>
#include <iostream>

using namespace std;
using namespace MySQLPlus;

int main (int argc, char **argv)
{
	if( argc != 3 )
	{
		cerr << "Usage:\n\t" << argv[0] << " database \"QUERY\"" << endl;
		return 0;
	}

	Connection con("root", "", argv[1], "dev.home");
	if( !con )
	{
		cerr << con.error() << endl;
		return 1;
	}
	cerr << ".Connected to " << argv[1] << " as root" << endl;

	Query q = con;
	q << argv[2];
	cerr << ".Query '" << q.preview() << '\'' << endl;
	Result res = q.store("NULL");
	if( !q )
	{
		cerr << q.error() << endl;
		return 1;
	}
	cerr << ".Query succesfull" << endl;

	for( long unsigned int i=0; i<res.cols(); ++i)
	{
		if( i ) cout << '\t';
		cout << res.fieldName( i ) << '(' << res[0].fieldNumber( res[1].fieldName( i ) ) << ')';
	}
	cout << endl;

	for( long unsigned int i=0; i<res.rows(); i++)
	{
		for( long unsigned int j=0; j<res.cols(); ++j )
		{
			if( j ) cout << '\t';
			cout << res[i][res.fieldName( j )];
		}
		cout << endl;
	}
	return 0;
}
