#include "pr_general.h"
#include "pr_socket.h"
#include <string.h>
#include <direct.h>

int pr::count = 0;

pr::pr(){
	if (count == 0)
		pr_init();
	count++;
}

pr::~pr(){
	count--;
	if (count == 0)
		pr_terminate();
}

/*
  Initialize PR library
*/
void pr::pr_init(void){
// Initializing Winsock library if on Windows
#ifdef WIN32
	WSADATA wsaData;
	int err = WSAStartup(MAKEWORD(1, 1), &wsaData);
#endif // WIN32
}

/*
  Free PR library
*/
void pr::pr_terminate(void){
// Terminating Winsock library
#ifdef WIN32
	WSACleanup();
#endif // WIN32
}

/*
  Return error string
*/
char* pr_strerror(unsigned long err){
	char static buffer[256];
#ifdef WIN32
	LPVOID lpMsgBuf;
	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM |
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		err,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR) &lpMsgBuf,
		0,
		NULL
		);
	if (strlen((char*)lpMsgBuf) < sizeof(buffer))
		strcpy(buffer, (char*)lpMsgBuf);
	else {
		strncpy(buffer, (char*)lpMsgBuf, sizeof(buffer) - 1);
		buffer[sizeof(buffer) - 1] = '\0';
	}
#else
	char* s = strerror((int)err);
	int len = (int)strlen(s);
	if (len < sizeof(buffer))
		strcpy(buffer, s);
	else {
		strncpy(buffer, s, sizeof(buffer) - 1);
		buffer[sizeof(buffer) - 1] = '\0';
	}
#endif // WIN32
	return buffer;
}

void GetFullPath(char* buf, char* name, unsigned int len){
	char path[256];
	_getcwd(path, sizeof(path));
	int _len = (int)strlen(path);
	if (_len + strlen(name) + 1 <= len){
#ifdef WIN32
		path[_len] = '\\';
#else
		path[_len] = '/';
#endif // WIN32
		path[_len + 1] = '\0';
		strcat(path, name);
	} else {
		buf[0] = '\0';
		return;
	}
	strcpy(buf, path);
}