#include "client.h"
#include <iostream>

using std::cout;
using std::endl;
using std::map;

Client::~Client(void){
	t_map::iterator i = clients.begin();
	t_map::const_iterator e = clients.end();
	while (i != e){
		delete i->second->protocol;
		delete i->second;
		i->second = NULL;
		i++;
	}
}

unsigned int Client::insertClient(Protocol* client, const char* IP){
	unsigned int id = getNextId();
	clients.insert(t_cortege(id, putInfo(client, IP)));
	cout << "User on " << IP << " inserted into class " << getClass() << endl;
	
	return id;
}

bool Client::CheckIP(string& IP){
	if (IPs.empty())
		return false;
	
	if (IPs.find(IP) == IPs.end())
		return false;

	return true;
}

int Client::Size(void){
	return (int)clients.size();
}

void Client::Handle(void){
	t_map::iterator i = clients.begin();
	t_map::const_iterator e = clients.end();

	while (i != e){
		if ((i->second != NULL) && (i->second->protocol != NULL)){
			if (!(i->second->protocol->Handle(RRData::t_params(getClass(), i->first)))){
				// something wrong with request parsing
				if (!(i->second->protocol->Online())){
					// user is offline. We should eliminate him
					delete i->second->protocol;
					i->second->protocol = NULL;
				}
			}
		}
		i++;
	}

	i = clients.begin();
	while (i != clients.end()){
		if ((i->second->protocol == NULL) || (i->second->deleted == true)){
			cout << "User on " << i->second->IP.c_str() << " removed from class " << getClass() << endl;
			delete i->second;
			i = clients.erase(i);
		} else {
			i++;
		}
	}
}

Client::t_info* Client::getClientInfo(unsigned int clientId){
	t_map::iterator i = clients.find(clientId);
	
	if (i == clients.end())
		return NULL;
	return i->second;
}

Client::t_info* Client::getClientInfo(const string& ip){
	t_map::iterator i = clients.begin();
	
	while (i != clients.end()){
		if (ip.compare(i->second->IP) == 0)
			return i->second;
		i++;
	}
	return NULL;
}