#include "handlers.h"

void req_DSQ(const RRData& in, RRData& out){
	if (isUnknown(in.params.param1)){
		res_400(in, out);
		return;
	}

	if (!isAdmin(in.params.param1)){
		res_401(in, out);
		return;
	}

	if (in.headers.find("IP") == in.headers.end()){
		res_404(in, out, "Obligatory header is missing");
		return;
	}

	if (in.command.parameter.empty()){
		res_404(in, out, "Obligatory parameter is missing");
		return;
	}

	string ip = in.headers.find("IP")->second;
	User::t_userInfo* info = (User::t_userInfo*)users.getClientInfo(ip);
	if (info == NULL){
		res_404(in, out, "Team with the IP address is absent");
		return;
	}

	int res;

	// disqualify team
	if (stricmp(in.command.parameter.c_str(), "set") == 0){
		info->disqualified = true;
		res = aux_disqualifyTeam(atoi(info->DBId.c_str()), true);
		if (!DBCheck(res, in, out)) return;
		res_205(in, out, "Team successfully disqualified");
		return;
	}

	// restore team
	if (stricmp(in.command.parameter.c_str(), "clear") == 0){
		info->disqualified = false;
		res = aux_disqualifyTeam(atoi(info->DBId.c_str()), false);
		if (!DBCheck(res, in, out)) return;
		res_205(in, out, "Team successfully restored");
		return;
	}

	res_404(in, out, "Wrong parameter");
}