#include "handlers.h"

void req_LOGOUT(const RRData& in, RRData& out){
	if (isUnknown(in.params.param1)){
		res_404(in, out, "Channel is already closed");
		return;
	}

	if (!in.command.parameter.empty()){
		res_404(in, out, "Unnecessary parameter");
		return;
	}

	switch(in.params.param1){
		case Client::t_tester:
			{
			Tester::t_testerInfo* info = (Tester::t_testerInfo*)testers.getClientInfo(in.params.param2);
			if (info == NULL){
				res_500(in, out, "Fatal error: dimeter");
				return;
			}
			unknown.insertClient(info->protocol, info->IP.c_str());
			info->deleted = true;
			res_201(in, out);
			return;
			}
		case Client::t_user:
			{
			User::t_userInfo* info = (User::t_userInfo*)users.getClientInfo(in.params.param2);
			unknown.insertClient(info->protocol, info->IP.c_str());
			if (info == NULL){
				res_500(in, out, "Fatal error: couple");
				return;
			}
			info->deleted = true;
			res_201(in, out);
			return;
			}
	}
}