#include "handlers.h"

void req_RATING(const RRData& in, RRData& out){
	if (isUnknown(in.params.param1)){
		res_400(in, out);
		return;
	}

	int res;
	if (!config.rating.frozen && !config.rating.actual){
		res = aux_updateRating(config.olympiad.OlympId, config.olympiad.OlympType, config.rating.data);
		if (!DBCheck(res, in, out)) return;
		config.rating.actual = true;
	}

	if ((config.rating.frozen) && isAdmin(in.params.param1)){
		map< int, t_ratingNode > data;
		res = aux_updateRating(config.olympiad.OlympId, config.olympiad.OlympType, data);
		if (!DBCheck(res, in, out)) return;
		if (strcmp(in.command.parameter.c_str(), "with-last-id") == 0)
			res_206(in, out, data, res);
		else
			res_206(in, out, data);
		return;
	}

	if (!config.rating.frozen)
		res = aux_getLastLogId(config.olympiad.OlympId, config.olympiad.OlympType);
	else
		res = config.rating.LastIdBeforeFreezing;

	if (!DBCheck(res, in, out)) return;
	if (strcmp(in.command.parameter.c_str(), "with-last-id") == 0)
		res_206(in, out, config.rating.data, res);
	else
		res_206(in, out, config.rating.data);
}