#include "handlers.h"

void req_READY(const RRData& in, RRData& out){
	if (isUnknown(in.params.param1)){
		res_400(in, out);
		return;
	}

	if (!isTester(in.params.param1)){
		res_401(in, out);
		return;
	}

	if (!in.command.parameter.empty()){
		res_404(in, out, "Unnecessary parameter");
		return;
	}
	
	Tester::t_testerInfo* info = (Tester::t_testerInfo*)testers.getClientInfo(in.params.param2);
	if (info == NULL){
		res_500(in, out, "Fatal error: gamble on a rise in prices");
		return;
	}

	//       READY
	if (info->serveTime != 0){
		info->ready = false;
		if (info->checkQueue.empty())
			testers.insertJob(info->job);
		unknown.insertClient(info->protocol, info->IP.c_str());
		info->deleted = true;
		res_404(in, out, "Request READY when task has been already appointed is not permitted. Channel is closed.");
		return;
	}

	if (info->reactivated == false)
		info->checkQueue.empty();

	if (!info->checkQueue.empty()){
		res_301(out, out, info->checkQueue.front().Task, info->checkQueue.front().Compiler, info->checkQueue.front().ProgramText);
		if (info->protocol->Online())
			info->protocol->Generate(out);
		info->serveTime = time(0);
		info->ready = false;
		return;
	}

	testers.makeReady(in.params.param2, out);
}