#include "handlers.h"

void req_STATUS_CHANGE(const RRData& in, RRData& out){
	if (isUnknown(in.params.param1)){
		res_400(in, out);
		return;
	}

	if (!isAdmin(in.params.param1)){
		res_401(in, out);
		return;
	}

	Admin::t_adminInfo* info = (Admin::t_adminInfo*)admins.getClientInfo(in.params.param2);
	if (info == NULL){
		res_500(in, out, "Fatal error: diamond");
		return;
	}

	if (in.command.parameter.empty()){
		res_404(in, out, "Obligatory parameter is missing");
		return;
	}

	// stop parameter
	if (stricmp(in.command.parameter.c_str(), "stop") == 0){
		if (config.olympiad.started == false){
			res_205(in, out, "Already stopped");
			return;
		}

		config.olympiad.started = false;
		config.rating.frozen = true;
		
		users.msg_olympiadStopped();

		res_205(in, out, "Olympiad successfully stoped");
		
		return;
	}

	// freeze parameter
	if (stricmp(in.command.parameter.c_str(), "freeze") == 0){
		config.rating.frozen = true;
		config.rating.LastIdBeforeFreezing = aux_getLastLogId(config.olympiad.OlympId, config.olympiad.OlympType);
		if (config.rating.LastIdBeforeFreezing < 0) config.rating.LastIdBeforeFreezing = 0;
		aux_updateRating(config.olympiad.OlympId, config.olympiad.OlympType, config.rating.data);
		
		res_205(in, out, "Rating successfully freezed");

		return;
	}

	// melt parameter
	if (stricmp(in.command.parameter.c_str(), "melt") == 0){
		config.rating.frozen = false;
		config.rating.LastIdBeforeFreezing = 0;
		config.rating.actual = false;

		res_205(in, out, "Rating successfully melted");

		return;
	}

	// cancel-freeze parameter
	if (stricmp(in.command.parameter.c_str(), "cancel-freeze") == 0){
		config.rating.frozen = false;
		config.rating.LastIdBeforeFreezing = 0;
		config.rating.actual = false;
		config.olympiad.RatingFreeze = 0;

		res_205(in, out, "Freeze successfully canceled");

		return;
	}

	res_404(in, out, "Wrong parameter");
}