#include "handlers.h"

void req_TASK(const RRData& in, RRData& out){
	if (isUnknown(in.params.param1)){
		res_400(in, out);
		return;
	}

	if (!isTeam(in.params.param1)){
		res_401(in, out);
		return;
	}
	
	bool force;
	if (!in.command.parameter.empty() && (stricmp(in.command.parameter.c_str(), "force") == 0))
		force = true;
	else
		force = false;

	if (!in.command.parameter.empty() && (force == false)){
		res_404(in, out, "Wrong parameter value");
		return;
	}

	if (config.olympiad.started == false){
		res_409(in, out);
		return;
	}

	User::t_userInfo* info = (User::t_userInfo*)users.getClientInfo(in.params.param2);
	if (info == NULL){
		res_500(in, out, "Fatal error: smallpox");
		return;
	}

	if (info->disqualified == true){
		res_403(in, out);
		int newId = unknown.insertClient(info->protocol, info->IP.c_str());
		info->deleted = true;
		return;
	}

	if ((in.headers.find("Task-Id") == in.headers.end()) ||
		(in.headers.find("Task") == in.headers.end()) ||
		(in.headers.find("Compiler") == in.headers.end())){
			res_404(in, out, "Obligatory headers are missing");
			return;
		}

	int tmp = aux_checkTask(in.headers.find("Task")->second, config.olympiad.OlympId, config.olympiad.OlympType);
	if (tmp == 0){ res_404(in, out, "Ivalid task number"); return; }
	if (tmp == -1){	res_500(in, out, "Database is not available"); return; }
	if (tmp == -2){	res_500(in, out, "Database error"); return; }
	
	tmp = aux_checkCompiler(in.headers.find("Compiler")->second, config.olympiad.OlympId);
	if (tmp == 0){ res_404(in, out, "Ivalid compiler id"); return; }
	if (tmp == -1){ res_500(in, out, "Database is not available"); return; }
	if (tmp == -2){ res_500(in, out, "Database error"); return; }

	tmp = aux_checkIfAlreadySolved(in.headers.find("Task")->second, config.olympiad.OlympId, config.olympiad.OlympType, info->DBId);
	if (tmp == -1){ res_500(in, out, "Database is not available"); return; }
	if (tmp == -2){ res_500(in, out, "Database error"); return; }
	
	bool alreadySolved;
	if (tmp == 0)
		alreadySolved = false;
	else
		alreadySolved = true;

	if (in.body.size() == 0){
		res_500(in, out, "Request without body");
		return;
	}

	string DBId;
	unsigned int penalty = (int)(time(0) - config.olympiad.StartTime);
	tmp = aux_registerNewTask(in.headers.find("Task")->second, info->DBId, in.body, config.olympiad.OlympId, config.olympiad.OlympType, penalty, DBId, config.tasksCoded, in.headers.find("Compiler")->second);

	// if task is solved and TASK request is without force parameter
	if ((force == false) && (alreadySolved == true)){ res_210(in, out, in.headers.find("Task-Id")->second); return; }

	if (tmp == -1){	res_500(in, out, "Database is not available"); }
	if (tmp == -2){	res_500(in, out, "Database error"); }
	if (tmp == 0){ res_500(in, out, "Can not register task in database"); }

	testers.insertJob(in.headers.find("Task-Id")->second, in.headers.find("Task")->second, in.headers.find("Compiler")->second, in.body, in.params.param2, DBId, info->DBId, penalty);
	if (tmp <= 0) return;
	res_101(in, out, in.headers.find("Task-Id")->second);
}