#include "unknown.h"

extern User users;
extern Tester testers;
extern Admin admins;
extern Configuration config;

using std::cout;
using std::endl;

UNknown::UNknown(){
	Reload();
}

Client::t_info* UNknown::putInfo(Protocol* protocol, const char* IP){
	t_unknownInfo* t = new t_unknownInfo(protocol, IP);
	t->connectTime = time(0);
	return (t_info*)t;
}

void UNknown::Reload(void){}

bool UNknown::CheckIP(string IP){
	return (users.CheckIP(IP) || testers.CheckIP(IP) || admins.CheckIP(IP));
}

void UNknown::RemoveTimeoutedClients(void){
	Client::t_map::iterator i = clients.begin();

	while (i != clients.end()){
		if (i->second->protocol != NULL){
			if (time(0) - ((t_unknownInfo*)(i->second))->connectTime > (time_t)config.timeouts.unknownTimeout){
				cout << "User on " <<  i->second->IP.c_str() << " removed due to timeout" << endl;
				delete i->second->protocol;
				delete i->second;
				i = clients.erase(i);
			} else {
				i++;
			}
		}
	}
}