#include "user.h"
#include "config.h"
#include "mysqlplus.h"
#include "handlers.h"
#include <iostream>

using namespace MySQLPlus;

extern Connection dbCon;
extern Configuration config;

using std::cout;
using std::endl;

User::User(){
	Reload();
}

void User::Reload(void){
	IPs.clear();
	//     IP 
	
	if (!dbCon) return;
	
	Query q = dbCon;
	q << "SELECT b.IP as ip FROM team as a, ip as b WHERE a.OlympId=";
	q << config.olympiad.OlympId;
	q << " AND a.IPId=b.IPId";

	Result res = q.store("NULL");
	if (!q || (int)res.rows() == 0) return;
	for (int i = 0; i < (int)res.rows(); i++){
		string ip = res[i]["IP"];
		if (!ip.empty())
			IPs.insert(ip);
	}
}

Client::t_info* User::putInfo(Protocol* protocol, const char* IP){
	return (t_info*)new t_userInfo(protocol, IP);
}

void User::msg_resultOfTesting(unsigned int clientId, const string& TaskId, const string& Result, const string& TestNumber){
	t_userInfo* info = (t_userInfo*)getClientInfo(clientId);
	if (info == NULL) return;
	
	RRData out;
	res_202(out, out, TaskId, Result, TestNumber);
	if (info->protocol->Online())
		info->protocol->Generate(out);
}

void User::msg_olympiadStarted(void){
	t_map::iterator i = clients.begin();
	t_map::iterator e = clients.end();

	RRData out;
	res_209(out, out);

	while (i != e){
		if ((i->second->protocol != NULL) && (i->second->protocol->Online())){
			i->second->protocol->Generate(out);
		}
		i++;
	}
}

void User::msg_olympiadStopped(void){
	t_map::iterator i = clients.begin();
	t_map::iterator e = clients.end();

	RRData out;
	res_214(out, out);

	while (i != e){
		if ((i->second->protocol != NULL) && (i->second->protocol->Online())){
			i->second->protocol->Generate(out);
			unknown.insertClient(i->second->protocol, i->second->IP.c_str());
			i->second->protocol = NULL;
		}
		i++;
	}
}